package fidgetspinnerimageviewwrapper;

import com.jentsch.fidgetspinnerview.FidgetSpinner;

import android.content.Context;
import android.graphics.Bitmap;
import android.graphics.drawable.Drawable;
import android.util.DisplayMetrics;
import android.view.ViewGroup;
import anywheresoftware.b4a.BA;
import anywheresoftware.b4a.BA.Author;
import anywheresoftware.b4a.BA.Hide;
import anywheresoftware.b4a.BA.Pixel;
import anywheresoftware.b4a.BA.ShortName;
import anywheresoftware.b4a.BA.Version;
import anywheresoftware.b4a.BALayout;
import anywheresoftware.b4a.BA.DependsOn;
import anywheresoftware.b4a.keywords.Common.DesignerCustomView;
import anywheresoftware.b4a.objects.LabelWrapper;
import anywheresoftware.b4a.objects.PanelWrapper;
import anywheresoftware.b4a.objects.ViewWrapper;
//import anywheresoftware.b4a.objects.TextViewWrapper;
import anywheresoftware.b4a.BA.ActivityObject;

import anywheresoftware.b4a.BA.Events;
//import android.view.MotionEvent;

//import android.graphics.Color;
//import android.graphics.Typeface;

import android.view.View;
import android.widget.TextView;
import android.widget.ImageView;
//import android.view.Gravity; 

//import android.util.Log;
//import android.view.ViewTreeObserver;

//import android.media.AudioFormat;
//import android.media.AudioRecord;
//import android.media.MediaRecorder;

import java.util.ArrayList;
import java.util.List;
//import java.util.Timer;
//import java.util.TimerTask;

//import android.os.Build;
import android.os.Bundle;


import android.os.Handler;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.view.MotionEvent;
import android.view.View.OnTouchListener;







@ActivityObject
@Events(values={"angle_changed(angle As Double)"})
@Author("Github: Michael jentsch(https://github.com/msoftware/FidgetSpinnerImageView?utm_source=android-arsenal.com&utm_medium=referral&utm_campaign=6148), Wrapped by: Johan Schoeman")
@Version(1.00f)
@ShortName("FidgetSpinner")
@DependsOn(values={"android-support-annotations"})
public class fidgetspinnerimageviewWrapper extends ViewWrapper<FidgetSpinner> implements DesignerCustomView {


	private BA ba;
	private String eventName;
    private FidgetSpinner cv;
	
	

	public void Initialize(BA ba, String EventName) {
		_initialize(ba, null, EventName);
	}

	@Hide
	public void _initialize(BA ba, Object activityClass, String EventName) {
		this.eventName = EventName.toLowerCase(BA.cul);
		this.ba = ba;
		cv = new FidgetSpinner(ba.context);
        this.setObject(cv);

		addListener3();

 	}
	
	
/*     public double calcActionUpSpeed() {
        return cv.calcActionUpSpeed();
    } 

     public boolean isPivot () {
        return cv.isPivot ();
    }

    public void setPivot(boolean pivot) {
        cv.setPivot(pivot);
		cv.invalidate();
    } 

     public float getCurrentSpeed() {
        return cv.getCurrentSpeed();
    }

    public void setCurrentSpeed(float currentSpeed) {
        cv.setCurrentSpeed(currentSpeed);
		cv.invalidate();
    }	 */
	 
	 
     @Hide
    public void addListener3(){

        cv.setCallback(new FidgetSpinner.Callback() {
            @Override
            public void angle_changed() {

              if (ba.subExists(eventName + "_angle_changed")) {
                ba.raiseEvent2(ba, false, eventName + "_angle_changed", true, new Object[]{cv.getCurrentAngle()});
              }
            }	
			
        });
    }
 
    public void addImage(String draw) {
		 int DrawableID = BA.applicationContext.getResources().getIdentifier(draw, "drawable", BA.packageName);
         cv.setImageDrawable(DrawableID);
    }


	
	//programmatically add view
    @Hide
	public void AddToParent(ViewGroup Parent, @Pixel int left, @Pixel int top, @Pixel int width, @Pixel int height) {
		Parent.addView(cv, new BALayout.LayoutParams(left, top, width, height));
	}
	
	//this method cannot be hidden.
  
        
	public void DesignerCreateView(PanelWrapper base, LabelWrapper lw, anywheresoftware.b4a.objects.collections.Map props) {
		ViewGroup vg = (ViewGroup) base.getObject().getParent();
		AddToParent(vg, base.getLeft(), base.getTop(), base.getWidth(), base.getHeight());
		base.RemoveView();
		//set text properties
	}



	public void setLeft(int left)	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		lp.left = left;
		cv.getParent().requestLayout();
	}

	public int getLeft()	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		return lp.left;
	}
	public void setTop(int top)	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		lp.top = top;
		cv.getParent().requestLayout();
	}
 
	public int getTop()	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		return lp.top;
	}
	
	public void setWidth(int Width)	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		lp.width = Width;
		cv.getParent().requestLayout();
	}

	public int getWidth()	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		return lp.width;
	}
	
	public void setHeight(int height)	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		lp.height = height;
		cv.getParent().requestLayout();
	}

	public int getHeight()	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		return lp.height;
	}
	
}
